#ifndef HARDWARE_H
#define HARDWARE_H

#include <io.h>
#include <signal.h>
#include <iomacros.h>

//Port Output Register :

#define P1OUT_INIT  0x00
#define P2OUT_INIT  0x00
#define P3OUT_INIT  0x00
#define P4OUT_INIT  0x00

//Port Direction Register 'P1DIR, P2DIR':

#define P1DIR_INIT  0xFF                    // Init of Port1 Data-Direction Reg (Out=1 / Inp=0)
#define P2DIR_INIT  0xB8                    // Init of Port2 Data-Direction Reg (Out=1 / Inp=0)
#define P3DIR_INIT  0x1F
#define P4DIR_INIT  0xFF

//Selection of Port or Module -Function on the Pins 'P1SEL, P2SEL'

#define P1SEL_INIT    0x00
#define P2SEL_INIT    0xC8
#define P3SEL_INIT    0x00
#define P4SEL_INIT    0x10

//Interrupt capabilities of P1 and P2

#define P1IE_INIT     0x00                    // Interrupt Enable (0=dis 1=enabled)
#define P2IE_INIT     0x00                    // Interrupt Enable (0=dis 1=enabled)
#define P1IES_INIT    0x00                    // Interrupt Edge Select (0=pos 1=neg)
#define P2IES_INIT    0x00                    // Interrupt Edge Select (0=pos 1=neg)

#define WDTCTL_INIT   WDTPW|WDTHOLD

// Encoder

#define ENCODER_PORT    P3IN

#define ENCODER_PHASE_A 0x20
#define ENCODER_PHASE_B 0x40
#define ENCODER_BUTTON  0x80

// Buttons

#define BUTTON_PORT     P2IN
#define BUTTON_MASK     (0x07)
#define BUTTON_LEFT     (1<<0)
#define BUTTON_RIGHT    (1<<1)
#define BUTTON_FIRE     (1<<2)

// Display

#define DIGIT_PORT P3OUT
#define DIGIT_DIGIT1 (1<<0)
#define DIGIT_DIGIT10 (1<<1)
#define DIGIT_DIGIT100 (1<<2)
#define DIGIT_DIGIT1000 (1<<3)
#define DIGIT_MASK 0x0F

#define SEG_PORT P1OUT

#endif //HARDWARE_H
