#include <io.h>
#include <signal.h>
#include "types.h"
#include "hardware.h"
#include "init.h"

void io_init(void)
{
    P1SEL  = P1SEL_INIT;                //Select port or module -function on port1
    P2SEL  = P2SEL_INIT;                //Select port or module -function on port2
    P3SEL  = P3SEL_INIT;
    P4SEL  = P4SEL_INIT;

    P1OUT  = P1OUT_INIT;
    P2OUT  = P2OUT_INIT;
    P3OUT  = P3OUT_INIT;
    P4OUT  = P4OUT_INIT;

    P1DIR  = P1DIR_INIT;                //Init port direction register of port1
    P2DIR  = P2DIR_INIT;                //Init port direction register of port2
    P3DIR  = P3DIR_INIT;
    P4DIR  = P4DIR_INIT;

    P1IES = P1IES_INIT;
    P1IE = P1IE_INIT;

    P2IES = P2IES_INIT;
    P2IE = P2IE_INIT;
}

void osc_init(void)
{
    uint16 i;

    DCOCTL = DCO2|DCO1;
    BCSCTL1 = XTS|DIVA_DIV1;
    _BIC_SR(OSCOFF);

    IFG1 &= ~OFIFG;
    
    BCSCTL3 = XCAP_0|LFXT1S_2;
    
    while(1)
    {
        IFG1 &= ~OFIFG;
        for(i=0;i<0xff;i++)
        {
            nop();
            nop();
        };
        if ((IFG1 & OFIFG) == 0)
          break;
    }
    BCSCTL2 = SELM_2|SELS|DIVS_DIV1|DIVM_DIV1;

}

void wdt_init(void)
{
    WDTCTL = WDTCTL_INIT;               //Init watchdog timer
}
